#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
// #define DEBUG
using namespace std;

#define int long long
typedef vector<int> vi;

void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		freopen("b.in", "r", stdin);
		freopen("b.out", "w", stdout);
	#endif
}

signed main(){
	fast_io();
	int n;
	cin >> n;
	vi speed(n);
	vi longg(n);
	int full_long = 0; long double full_time = 0;
	for(int i=0; i<n; i++){
		cin >> speed[i];
	}
	for(int i=0; i<n; i++){
		cin >> longg[i];
	}
	int m;
	cin >> m;
	// cerr << m << endl;
	vi kek(m+1, 0);
	kek[m] = 1e12;
	vi plati(m);
	for(int i=1; i<m; i++)
		cin >> kek[i];
	for(int i=0; i<m; i++)
		cin >> plati[i];
	int q;
	cin >> q;
	// cerr << q << endl;
	vector<long double> aoaoao(m+1);
	for(int i=0; i<=m; i++){
		long double keklol = 0.0;
		for(int j=0; j<n; j++){
			keklol += (longg[j]+0.0)/(speed[j]+kek[i]+0.0);
		}
		aoaoao[i] = keklol;
		// cerr << fixed << aoaoao[i] << " ";
	}
	vi ans(q);
	for(int i=0; i<q; i++){
		int a, b;
		cin >> a >> b;
		int l = 0, r = m;
		int answer = 0;
		while(l<=r){
			int mid = l+(r-l)/2;
			if(aoaoao[mid]<= b-a){
				answer = mid;
				r = mid-1;
			} else{
				l = mid+1;
			}
		}
		if(answer==0){
			ans[i] = 0;
		} else{
			ans[i] = plati[answer-1];
		}
	}
	for(int i:ans)
		cout << i << endl;
	return 0;
}