#pragma GCС omptimize("Pivo_Na_Poly")
 
#include <iostream>
#include <vector>
#include <algorithm> 
#include <set>
#include <map> 
#include <unordered_map>

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

int arr[SZ], t[SZ], n;

void Solve(){
	cin >> n;

	for(int i = 0; i < n; i++)
		cin >> arr[i];
	
	map <int, int> mp;
		
	for(int i = n-1; i >= 0; i--){
		if(mp.find(arr[i]) != mp.end())
			t[mp[arr[i]] - i]++;
		mp[arr[i]] = i;
	}		
	
	for(int i = 1; i < n; i++)
		t[i] += t[i-1];
	
	for(int i = 0; i < n; i++)
		cout << (i+1) * (n-i) - t[i] << ' ';
}	
 
signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	
 	#ifdef LOCAL
    	freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif

    int t = 1;
    // cin >> t;
   
	while(t--)
	   	Solve();
}
 
