#pragma GCС optimize("Pivo_Na_Poly")
#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm> 
#include <map> 
#include <unordered_map>

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

int arr[SZ], n;

void f(int l){
	if(l == 1){
		cout << n << ' ';
		return;
	}
	
	map<int, int> mp;
	
	for(int i = 0; i < l; i++)
		mp[arr[i]]++;

	ll S = mp.size(), k = S;
	
	for(int i = l; i < n; i++){
		if(!(--mp[arr[i-l]]))
			k--;
		
		k += !(mp[arr[i]]);
		mp[arr[i]]++;
		
		S += k;
	}
	
	cout << S << ' ';
}

void Solve(){
	cin >> n;

	for(int i = 0; i < n; i++)
		cin >> arr[i];
		
	for(int i = 1; i <= n; i++)
		if(n <= 5000)
			f(i);	
}	
 
signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	
 	#ifdef LOCAL
    	freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif

    int t = 1;
    // cin >> t;
   
	while(t--)
	   	Solve();
}