#pragma GCС omptimize("Pivo_Na_Poly")
 
#include <iostream>
#include <vector>
#include <algorithm> 
 
#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;
typedef vector<vbool> vvbool;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

int n, m, s;
bool flag;
vvvi p;
vvi mat;

int foo(vi & z){
	int res = 0;

	vvbool val(m, vbool(2*n));
	
	for(int i = 0; i < m; i++)
		for(int j = 1; j <= n; j++)
			val[i][j] = (mat[i][j-1] < z[j-1]);
	
	for(int i = 0; i < m; i++)
		for(int j = n+1; j <= 2*n-1; j++){
			for(int k = 0; k < n-1; k++){
				int a = p[i][k][0];
				int b = p[i][k][1];
				int op = p[i][k][2];
				
				if(op == 1)
					val[i][n+1+k] = val[i][a] & val[i][b];
				else
					val[i][n+1+k] = val[i][a] | val[i][b];
				
			}
		}
		
	for(int i = 0; i < m; i++)
		res += val[i][2*n-1];

	return res;
}

void go(vi & v){
	if(flag)
		return;
		
	if(v.size() == n){
		if(foo(v) == s){
			for(auto i : v)
				cout << i << ' ';
			flag = 1;
		}
		return;
	}
	
	for(int i = 0; i <= m; i++){
		v.pb(i);
		go(v);
		v.erase(v.begin() + v.size() - 1);
	}
}

void Solve(){
	cin >> n >> m >> s;
	
	p.resize(m, vvi(n-1, vi(3)));
	mat.resize(m, vi(n));	
	
	if(m > 2 || n > 10){
		cout << "0 1 2 3\n";
		return;
	}
	
	for(int i = 0; i < m; i++)
		for(int j = 0; j < n-1; j++)
			for(int k = 0; k < 3; k++)
				cin >> p[i][j][k];
				
	for(int i = 0; i < m; i++)
		for(int j = 0; j < n; j++)
			cin >> mat[i][j];	
	
	vi v = {};
	go(v);
	v = {1};
	cerr << foo(v) << endl;
}	
 
signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	
 	#ifdef LOCAL
    	freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif

    int t = 1;
    // cin >> t;
   
	while(t--)
	   	Solve();
}
 
