#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 5000 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, a[MAXN];

void compress(){
	vector <pii> v(n);
	for(int i = 0; i < n; i++)
		v[i] = {a[i], i};
	sort(v.begin(), v.end());
	int last = v[0].f, val = 0;
	for(int i = 0; i < n; i++){
		if(v[i].f > last)
			val++;
		a[v[i].s] = val;
		last = v[i].f;
	}
}

int main(){
	fastIO();
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> a[i];
	compress();
	vi cnt(n);
	for(int d = 1; d <= n; d++){
		int cur_res = 0;
		for(int i = 0; i < d; i++){
			if(cnt[a[i]] == 0)
				cur_res++;
			cnt[a[i]]++;
		}
		ll sum = cur_res;
		for(int i = d; i < n; i++){
			if(cnt[a[i - d]] == 1)
				cur_res--;
			cnt[a[i - d]]--;
			if(cnt[a[i]] == 0)
				cur_res++;
			cnt[a[i]]++;
			sum += cur_res;	
		}
		fill(cnt.begin(), cnt.end(), 0);
		cout << sum << ' ';
	}
	
	



	return 0;
}