#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

int n, m, s;
vector <vector <pair <pii, int> > > instr;
vector <vi> table;
int num_in_col[MAXN];

void solve1(){
	cout << s;
	exit(0); 
}

void solve2(){
	for(int i = 0; i < m; i++)
		num_in_col[table[i][0]] = i;
		for(int i = 0; i < m; i++)
			cerr << num_in_col[i] << ' ';	
	set <int> st;
	for(int i = 0; i < m; i++){
		if(instr[i][0].s == 2)
			st.insert(table[i][1]);
	}
	int cur = 0;
	for(int z1 = 0; z1 <= m; z1++){
		if(z1 > 0){
			int row = num_in_col[z1 - 1];
			if(instr[row][0].s == 1)
				st.insert(table[row][1]);
			else{
				cur++;
				st.erase(table[row][1]);
			}
		}
		if(s - cur >= 0 && s - cur <= (int)st.size()){
			cout << z1 << ' ';
			for(int i = 0; i < (s - cur - 1); i++)
				st.erase(st.begin());
			cout << *st.begin() + 1;
			exit(0); 
		}
	}
}

int main(){
	fastIO();
	cin >> n >> m >> s;
	instr.resize(m);
	for(int i = 0; i < m; i++){
		for(int j = 0; j < n - 1; j++){
			int id1, id2, op;
			cin >> id1 >> id2 >> op;
			instr[i].pb({{id1 - 1, id2 - 1}, op});
		}
	}
	table.resize(m);
	for(int i = 0; i < m; i++){
		table[i].resize(n);
		for(int j = 0; j < n; j++)
			cin >> table[i][j];
	}
	if(n == 1)
		solve1();	
	else if(n == 2)
		solve2();



	return 0;
}