#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#define ll long long
#define ld long double
#define ul unsigned long long
#define fori(x, y) for(long long i = x; i != y; i += ((x < y)? 1 : -1))
#define forj(x, y) for(long long j = x; j != y; j += ((x < y)? 1 : -1))
#define p(x, y) make_pair(x, y) 
using namespace std;
const ld eps = 1e-5;
const ll MAXN = 100009;
void fastIO()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}
ll n, m, s, ln, rn, midn, lm, rm, midm, a, b, op;
vector <pair <ll, pair<pair<ll, ll>, ll>>> ch[300009];
map<ll, ll> num;
vector<vector<int>> mat, nowmat;
vector <ll> z;
void addto(int w)
{
	if (z[w] == m)
		addto(w - 1);
	z[w] = (z[w] + 1) % (m + 1);
}
ll binpow(ll a,  ll b)
{
	if (b == 1)
		return a;
	ll k = binpow(a, b / 2);
	if (b % 1)
		return k * k + 1;
	else
		return k * k;
}
int main()
{
	fastIO();
	cin >> n >> m >> s;
	mat.resize(m);
	nowmat.resize(m);
	for (int i = 0; i < m; i++)
	{
		mat[i].resize(n);
		nowmat[i].resize(2 * n);
		for (int j = 0; j < n - 1; j++)
		{
			cin >> a >> b >> op;
			ch[i].push_back(p(max(a - 1, b - 1), p(p(a - 1, b - 1), op)));
			num[max(a - 1, b - 1)] = j;
		}
		sort(ch[i].begin(), ch[i].end());
	}
	fori(0, m)
		forj(0, n)
			cin >> mat[i][j];
	z.resize(n);
	rn = n + 1;
	ln = -1;
	while (rn - ln > 1)
	{
		lm = -1;
		rm = m;
		midn = (rn + ln) / 2;
		while (rm - lm > 1)
		{
			midm = (rm + lm) / 2;
			ll lans = 0;
			op = 0;
			fori(0, m)
				forj(0, n)
				{
					if (j < midn || (j == midn && mat[i][j] < midm))
						nowmat[i][j] = 0;
					else
						nowmat[i][j] = 1;
				}
			for (int w = 0; w < m; w ++)
			{
				for (int i = 0; i < n - 1; i++)
				{
					int yo = 0;
					if ((ch[w][i].second.second == 1) && (nowmat[i][ch[w][i].second.first.first] & nowmat[i][ch[w][i].second.first.second]))
						yo = 1;
					if ((ch[w][i].second.second == 2) && (nowmat[i][ch[w][i].second.first.first] | nowmat[i][ch[w][i].second.first.second]))
						yo = 1;
					nowmat[w][n + num[ch[w][i].first]] = yo;
				}
			}
			for (int i = 0; i < m; i++)
				if (nowmat[i][2 * n - 2] == 1)
					lans++;
			if (lans == s)
			{
				for (int i = 0; i < midn; i ++)
					cout << 0 << " ";
				cout << midm << " ";
				for (int i = midn + 1; i < n; i ++)
					cout << m << " ";
				return 0;
			}
			if (lans < s)
				rm = midm;
			else
				lm = midm;
		}
		if (rm == m)
			ln = midn;
		else
			rn = midn;
	}
	return 0;
}	
