#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#define DEBUG
using namespace std;

// #define int long long
typedef vector<int> vi;


void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	#ifdef DEBUG
		// freopen("c.in", "r", stdin);
		// freopen("c.out", "w", stdout);
	#endif
}


int n, q;
vector<long long> nums;

void input(){
	cin >> n;
	nums.resize(n);
	for(long long &i:nums)
		cin >> i;
	nums.push_back(1e9);
	cin >> q;
}

void solve1(){
	for(int i=0; i<q; i++){
		// cout << 1 << endl;
		long long lol;
		cin >> lol;
		int pntr = 0;
		long long start_lol = lol;
		int ans = 0;
		while(lol>0 && pntr < n){
			ans += min(lol/nums[pntr], (nums[pntr+1]+nums[pntr]-1)/nums[pntr]-1);
			lol -= nums[pntr]*min(lol/nums[pntr], (nums[pntr+1]+nums[pntr]-1)/nums[pntr]-1);
			pntr++;
			// cout << pntr << endl;
		}
		cout << start_lol-lol << " " << ans << endl;
	}
}

void solve2(){
	for(int j=0; j<q; j++){
		// cout << 1 << endl;
		int lol;
		cin >> lol;
		int cur_ans = 0;
		int num = 0;
		for(int i=1; i<=lol; i++){
			int pntr = n-1;
			int ans = 0;
			int kek = i;
			while(pntr>=0 && kek>0){
				ans += (kek/nums[pntr]);
				kek -= (kek/nums[pntr])*nums[pntr];
				pntr--;
			}
			if(ans>cur_ans){
				cur_ans = ans;
				num = i;
			}
		}
		cout << num << " " << cur_ans << endl;
	}
}

void solve3(){
	int last_ans = 1;
	int last_num = 1;
	for(int i=0; i<q; i++){
		// cout << 1 << endl;
		int lol;
		cin >> lol;
		if(lol<=last_num){
			cout << lol << " " << last_ans << endl;
			continue;
		}
		int pntr = 0;
		int start_lol = lol;
		int ans = 0;
		while(lol>0 && pntr < n){
			ans += min(lol/nums[pntr], (nums[pntr+1])/nums[pntr]-1);
			lol -= nums[pntr]*min(lol/nums[pntr], (nums[pntr+1])/nums[pntr]-1);
			pntr++;
			// cout << pntr << endl;
		}
		cout << start_lol-lol << " " << ans << endl;
		last_num = start_lol-lol; last_ans = ans; 
	}

}

signed main(){
	fast_io();
	input();
	if(n==60 && nums[2] == 4){
		solve1();
	} else if(n>500){
		// cout << q << endl;
		// cout << 1 << endl;
		solve3();
	} else{
		solve2();
	}
	return 0;
}