#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#define DEBUG
using namespace std;

#define int long long
typedef vector<int> vi;


void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		// freopen("c.in", "r", stdin);
		// freopen("c.out", "w", stdout);
	#endif
}

int n, q;
vi nums;

int check(){
	int ans = 0;
	for(int i=0; i<(1<<n); i++){
		int cur_ans = 0;
		bool ok = true;
		int cnt = 0;
		for(int j=0; j<n*2; j++){
			if((1<<j%n)&i){
				cnt++;
				if(cnt>=4){
					ok = false;
				}
				if(j<n)
					cur_ans += nums[j];
			} else{
				cnt = 0;
			}
		}
		if(ok)
			ans = max(ans, cur_ans);
	}
	return ans;
}

signed main(){
	fast_io();
	cin >> n;
	nums.resize(n*2);
	for(int i=0; i<n; i++)
		cin >> nums[i];
	for(int j=n; j<n*2; j++)
		nums[j] = nums[j-n];
	cin >> q;
	cout << check() << endl;
	for(int j=0; j<q; j++){
		int a, b;
		cin >> a >> b;
		a--;
		nums[a] = b;
		cout << check() << endl;
	}
	return 0;
}