#pragma GCС omptimize("Pivo_Na_Poly")
 
#include <iostream>
#include <vector>
#include <algorithm> 
#include <set>
#include <map> 

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

void Solve(){
    ll ans = 0, n, x;
    cin >> n >> x;

    for(ll i = 1; i <= (n<<1); i++){
        if(i == x)
            continue;
        for(ll j = 1; j <= (n<<1); j++){
            if(j == x)
                continue;
            for(ll k = 1; k < i; k++){
                if(!((i*j-n) % k)){
                    ll d = (i*j-n) / k;
                    if(d >= j || d <= 0)
                        continue;
                    ans += ((i*j) - (k*d) == n);
                }
            }
        }
    }

    cout << ans << endl;
}	
 
signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	
 	#ifdef LOCAL
    	freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif

    int q = 1;
    // cin >> q;
   
	while(q--)
	   	Solve();
}