#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 3000 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, x;
vector <vector <pii> > ab, cd;

void fill_ab(){
	ab.resize(n * n + 1);
	for(int a = 1; a <= n; a++){
		if(a == x)
			continue;
		for(int b = 1; b <= n; b++){
			if(b == x)
				continue;
			ab[a * b].pb({a, b});
		}
	}
	for(int i = 1; i <= n * n; i++)
		sort(ab[i].begin(), ab[i].end());
}

void fill_cd(){
	cd.resize(n * n + 1);
	for(int a = 1; a <= n; a++){
		for(int b = 1; b <= n; b++)
			cd[a * b].pb({a, b});
	}
	for(int i = 1; i <= n * n; i++)
		sort(cd[i].begin(), cd[i].end());
} 

int fen[MAXN];

void add(int pos){
	while(pos <= n){
		fen[pos]++;
		pos |= (pos + 1);
	}
}

void del(int pos){
	while(pos <= n){
		fen[pos]--;
		pos |= (pos + 1);
	}
}

int get(int pos){
	int res = 0;
	while(pos >= 0){
		res += fen[pos];
		pos = (pos & (pos + 1)) - 1;
	}
	return res;
}

int main(){
	fastIO();
	cin >> n >> x;
	
	fill_ab();
	fill_cd();
	
	ll ans = 0;
	for(int i = n + 1; i <= n * n; i++){
		int id2 = 0;
		for(int id1 = 0; id1 < ab[i].size(); id1++){
			while(id2 < cd[i - n].size() && ab[i][id1].f > cd[i - n][id2].f){
				add(cd[i - n][id2].s);
				id2++;
			}
			ans += get(ab[i][id1].s - 1);
		}
		for(int j = 0; j < id2; j++)
			del(cd[i - n][j].s);
	}
	cout << ans;
	return 0;
}