#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 3000 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, x;

ll fen[MAXN];

void add(int pos){
	while(pos <= n){
		fen[pos]++;
		pos |= (pos + 1);
	}
}

void del(int pos){
	while(pos <= n){
		fen[pos]--;
		pos |= (pos + 1);
	}
}

ll get(int pos){
	ll res = 0;
	while(pos >= 0){
		res += fen[pos];
		pos = (pos & (pos + 1)) - 1;
	}
	return res;
}

int uk[MAXN];
vector <pii> prev_block[MAXN], cur_block[MAXN];


int main(){
	fastIO();
	cin >> n >> x;
	for(int i = 1; i <= n; i++){
		for( ; uk[i] <= n && i * uk[i] <= n; uk[i]++){
			prev_block[i * uk[i]].pb({i, uk[i]});
		}
	}
	for(int i = 1; i <= n; i++)
		sort(prev_block[i].begin(), prev_block[i].end());
	ll ans = 0;
	for(int num = 1; num < n; num++){
		int l = num * n, r = (num + 1) * n;
		for(int i = 1; i <= n; i++){
			for( ; uk[i] <= n && i * uk[i] <= r; uk[i]++)
				cur_block[i * uk[i] - l].pb({i, uk[i]});
		}
		for(int i = 1; i <= n; i++){
			sort(cur_block[i].begin(), cur_block[i].end());
			int id2 = 0;
			for(int id1 = 0; id1 < cur_block[i].size(); id1++){
				while(id2 < prev_block[i].size() && prev_block[i][id2].f < cur_block[i][id1].f){
					add(prev_block[i][id2].s);
					id2++;
				}
				if(cur_block[i][id1].f == x || cur_block[i][id1].s == x)
					continue;
				ans += get(cur_block[i][id1].s - 1);
			}
			for(int id1 = 0; id1 < id2; id1++)
				del(prev_block[i][id1].s);
			prev_block[i] = cur_block[i];
			cur_block[i].clear();
		}		
	}
	cout << ans;
	
	
	return 0;
}