#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 4 * 1e4 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

int n, q;
ll a[MAXN];
ll dp[MAXN][2][4];
bool in[MAXN];

ll calc(){
	int from[MAXN][4];
	for(int i = 0; i < n; i++){
		for(int j = 0; j < 4; j++){
			dp[i][0][j] = -1;
			dp[i][1][j] = -1;
			from[i][j] = -1;
		}
	}
	dp[2][1][3] = a[0] + a[1] + a[2];
	dp[1][1][2] = a[0] + a[1];
	dp[0][1][1] = a[0];
	dp[0][0][0] = 0;
	for(int i = 1; i < n; i++){
		for(int cnt = 0; cnt <= min(i, 3); cnt++){
			if(cnt == 0){
				for(int j = 0; j < 4; j++)
					dp[i][0][j] = max({dp[i][0][cnt], dp[i - 1][0][j], dp[i - 1][1][j]});
			}
			else{
				ll sum = 0;
				for(int j = 0; j < cnt; j++)
					sum += a[i - j];
				for(int j = 0; j < 4; j++){
					if(i == n - 1 && cnt + j > 3)
						continue;
					if(dp[i][1][j] < (dp[i - cnt][0][j] + sum)){
						dp[i][1][j] = dp[i - cnt][0][j] + sum;
						from[i][j] = i - cnt - 1;
					}
				}
			}
		}
	}
	ll ans = -1;
	pii start;
	for(int i = 0; i < 4; i++){
		if(dp[n - 1][0][i] > ans){
			ans = dp[n - 1][0][i];
			start = {0, i};
		}
		if(dp[n - 1][1][i] > ans){
			ans = dp[n - 1][1][i];
			start = {1, i};
		}
	}
	if(start.f == 1)
		start.f = n - 1;
	else
		start.f = n - 2;
	in[start.f] = 1;
	while(from[start.f][start.s] != -1){
		start.f = from[start.f][start.s];
		in[start.f] = 1;
	}
	for(int i = n - 1; i >= 0; i--){
		if(in[i] == 0 && in[(i - 1 + n) % n] == 0)
			in[i] = 1;
	}
	return ans;
}



int main(){
	fastIO();
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> a[i];
	ll ans = calc();
	cout << ans << endl;
	cin >> q;
	while(q--){
		int pos, val;
		cin >> pos >> val;
		a[pos - 1] = val;
		cout << calc() << '\n';
	}
	//for(int i = 0; i < n; i++)
	//	cerr << in[i] << ' ';

	return 0;
}