#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#define ll long long
#define ld long double
#define ul unsigned long long
#define fori(x, y) for(long long i = x; i != y; i += ((x < y)? 1 : -1))
#define forj(x, y) for(long long j = x; j != y; j += ((x < y)? 1 : -1))
#define p(x, y) make_pair(x, y) 
using namespace std;
const ld eps = 1e-5;
const ll MAXN = 100009;
void fastIO()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}
ll n, q;
ll mas[80002], dp[80009];
ll solve(ll k)
{
	dp[k] = 0;
	dp[1 + k] = mas[1 + k];
	dp[2 + k] = mas[1 + k] + mas[2 + k];
	dp[3 + k] = mas[1 + k] + mas[2 + k] + mas[3 + k];
	for (int i = 4 + k; i <= n + k; i++)
		dp[i] = max(max(dp[i - 2] + mas[i], dp[i - 3] + mas[i] + mas[i - 1]), dp[i - 4] + mas[i] + mas[i - 1] + mas[i - 2]);
	return max(dp[n - 2 + k], dp[n - 1 + k]);
}
int main()
{
	fastIO();
	cin >> n;
	for (int i = 1; i <= n; i++)
	{
		cin >> mas[i];
		mas[n + i] = mas[i];
	}
	cin >> q;
	ll reans = 0, er;
	for (int i = 1; i < 5; i++)
		reans = max(reans, solve(i));
	cout << reans << "\n";
	for (int qw = 0; qw < q; qw++)
	{
		cin >> er;
		cin >> mas[er];
		mas[n + er] = mas[er];
		reans = 0;
		for (int i = 1; i < 5; i++)
			reans = max(reans, solve(i));
		cout << reans << "\n";
	}
	return 0;
}