#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
// #define DEBUG
using namespace std;

// #define int long long
typedef vector<int> vi;

void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		freopen("b.in", "r", stdin);
		freopen("b.out", "w", stdout);
	#endif
}

signed main(){
	fast_io();
	int n;
	cin >> n;
	vi speed(n);
	vi longg(n);
	int full_long = 0; long double full_time = 0;
	for(int i=0; i<n; i++){
		cin >> speed[i];
	}
	for(int i=0; i<n; i++){
		cin >> longg[i];
	}
	int m;
	cin >> m;
	// cerr << m << endl;
	vi kek(m, 0);
	vi plati(m);
	for(int i=1; i<m; i++)
		cin >> kek[i];
	for(int &i:plati)
		cin >> i;
	int q;
	cin >> q;
	// cerr << q << endl;
	while(q--){
		int keklol, a, b;
		cin >> a >> b;
		keklol = b-a;
		int l = 0, r = m-1;
		int answer = 0;
		while(l<=r){
			int mid = l+(r-l)/2;
			long double time = 0;
			for(int i=0; i<n; i++){
				time += longg[i]/(speed[i]+0.0+kek[mid]);
			}
			if(time <= keklol){
				answer = mid;
				r = mid-1;
			} else{
				l = mid+1;
			}
		}
		if(answer == 0){
			cout << 0 << endl;
		} else{
			cout << plati[answer-1] << endl;
		}
	}
	return 0;
}