#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <algorithm>
// #define DEBUG
using namespace std;

typedef vector<int> vi;


void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		freopen("c.in", "r", stdin);
		freopen("c.out", "w", stdout);
	#endif
}

const int N = 2e5;
int t[N*4];
int cnt[N*4];

void push(int v, int l, int r){
	if(cnt[v]!=0){
		t[v] += cnt[v]*(r-l+1);
		if(r!=l){
			cnt[v*2] = cnt[v];
			cnt[v*2+1] = cnt[v];
		}
		cnt[v] = 0;
	}
}

void update(int v, int l, int r, int ql, int qr, int k){
	if(ql<=l && r<=qr){
		cnt[v] += k;
	} else if(ql>r || l>qr){
		return;
	} else{
		push(v, l, r);
		int mid = l+(r-l)/2;
		update(v*2, l, mid, ql, qr, k);
		update(v*2+1, mid+1, r, ql, qr, k);
		t[v] = t[v*2]+t[v*2+1];
	}
}

int get(int v, int l, int r, int k){
	push(v, l, r);
	if(l==r){
		return t[v];
	} else{
		int mid = l+(r-l)/2;
		if(k<=mid)
			return get(v*2, l, mid, k);
		else
			return get(v*2+1, mid+1, r, k);
	}
}

signed main(){
	fast_io();
	int n;
	cin >> n;
	vi nums(n);
	for(int &i:nums)
		cin >> i;
	vi lol(51, -1);
	for(int i=1; i<=n; i++){
		lol[nums[i-1]] = i;
		vi kek;
		kek = lol;
		sort(kek.begin(), kek.end());
		reverse(kek.begin(), kek.end());
		int last = kek[0];
		for(int j=0; j<51; j++){
			cerr << last << endl;
			if(kek[j]==-1){
				// cerr << last+1 << " " << i << endl; 
				update(1, 0, 2e5, last, i, j);
				break;
			} else{
				// cerr << i-last+1 << " " << i-kek[j]+1 << endl;
				update(1, 0, 2e5, i-last+1, i-kek[j]+1, j+1);
				last = kek[j];
			}	
		}
	}
	for(int i=1; i<=n; i++)
		cout << get(1, 0, 2e5, i) << " ";
	return 0;
}