#pragma GCС omptimize("Pivo_Na_Poly")
 
#include <iostream>
#include <vector>
#include <algorithm> 
 
#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

ll v[11], l[11];
ll f[SZ], vf[SZ];
ld need_v, all_S, all_v, need_t;
int n, m;

ld fo(ld dv){
	ld t = 0;

	for(int i = 1; i <= n; i++)
		t += ((ld)l[i] / ((ld)v[i] + dv));
		
	return t;
}

ld bs(ld t){
	ld l = 0, r = 1e9+42.42, mid;

	while(r - l > eps){
		mid = (l+r) / 2;
		
		if(fo(mid) < t)
			r = mid;
		else
			l = mid;	
	}
	
	return r;
}

ll bs1(ld k){
	int l = -1, r = m, mid;
	
	while(r - l > 1){
		mid = (l+r) >> 1;

		if(vf[mid] > k)
			r = mid;
		else
			l = mid;
	}
	
	return f[r];
}

ll foo(ld t){
	if(t+eps >= need_t)
		return 0;

	ld k = bs(t);	
	return bs1(k);
}

void Solve(){
	int q;
	cin >> n;
	
	for(int i = 1; i <= n; i++)
		cin >> v[i];
	for(int i = 1; i <= n; i++)
		cin >> l[i];

	cin >> m;
	
	for(int i = 1; i <= m-1; i++)
		cin >> vf[i];
	for(int i = 1; i <= m; i++)
		cin >> f[i];

	for(int i = 1; i <= n; i++)	
		need_t += ((ld)l[i] / (ld)v[i]);

	cin >> q;
	
	while(q--){
		int S, F;
		cin >> S >> F;
		cout << foo(F-S) << endl;
	}
}	
 
signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	
 	#ifdef LOCAL
    	freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
	#endif

    int t = 1;
    // cin >> t;
   
	while(t--)
	   	Solve();
}
 
