#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

int n, m, q;
ll max_speed[10], length[10];
ll a[MAXN], fee[MAXN];

bool check(ll T, int pos){
	ll min_add = (pos == 0 ? 0 : a[pos - 1]), max_add = (pos == m - 1 ? INF * INF : a[pos]);
	//cerr << min_add << ' ' << max_add << endl;
	ld min_time = 0, max_time = 0;
	for(int i = 0; i < n; i++){
		min_time += (ld)length[i] / (ld)(max_speed[i] + max_add);
		max_time += (ld)length[i] / (ld)(max_speed[i] + min_add);
	}
	//cerr << min_time << ' ' << max_time << ' ' << T << endl;
	if((ld)T < max_time)
		return true;
	return false;	
}

ll solve(ll T){
	int l = -1, r = m;
	while(r - l > 1){
		int mid = (l + r) / 2;
		check(T, mid) ? l = mid : r = mid;
	}
	if(l == -1)
		return 0;
//	cerr << check(T, 2);
	return fee[l];
}


int main(){
	fastIO();
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> max_speed[i];
	for(int i = 0; i < n; i++)
		cin >> length[i];
	cin >> m;
	for(int i = 0; i < m - 1; i++)
		cin >> a[i];
	for(int i = 0; i < m; i++)
		cin >> fee[i];
	cin >> q;
	while(q--){
		ll from, to;
		cin >> from >> to;
		cout << solve(to - from) << '\n';
		//exit(0);
	}
	
	



	return 0;
}