#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;

int n, m, s;
vector <vector <pair <pii, int> > > instr;
vector <vi> table;
int num_in_col[MAXN];

void solve1(){
	cout << s;
	exit(0); 
}

void solve2(){
	if(s == 0){
		cout << 0 << ' ' << 0;
		exit(0);
	}
	vi ors, ands;
	for(int i = 0; i < m; i++){
		if(instr[i][0].s == 1)
			ands.pb(table[i][1]);
		else
			ors.pb(table[i][0]);
	}
	sort(ors.begin(), ors.end());
	sort(ands.begin(), ands.end());
	if(ors.size() >= s){
		cout << ors[s - 1] + 1 << ' ' << 0;
		exit(0);
	}
	cout << m << ' ';
	s -= ors.size();
	cout << ands[s - 1] + 1;
}

int main(){
	fastIO();
	cin >> n >> m >> s;
	instr.resize(m);
	for(int i = 0; i < m; i++){
		for(int j = 0; j < n - 1; j++){
			int id1, id2, op;
			cin >> id1 >> id2 >> op;
			instr[i].pb({{id1 - 1, id2 - 1}, op});
		}
	}
	table.resize(m);
	for(int i = 0; i < m; i++){
		table[i].resize(n);
		for(int j = 0; j < n; j++)
			cin >> table[i][j];
	}
	if(n == 1)
		solve1();	
	else if(n == 2)
		solve2();



	return 0;
}