#include <iostream>
#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <algorithm>
#define DEBUG
using namespace std;

#define int long long
typedef vector<int> vi;

void fast_io(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	#ifdef DEBUG
		// freopen("a.in", "r", stdin);
		// freopen("a.out", "w", stdout);
	#endif
}

signed main(){
	fast_io();
	int n;
	cin >> n;
	vi nums(n);
	if(n==2){
		cout << 1 << endl;
		return 0;
	}
	for(int &i:nums)
		cin >> i;
	for(int i=1; i<n; i++)
		nums[i] += nums[i-1];
	int answer = 0;
	int aim = nums[n-1]/2;
	vector<pair<int, int>> kek;
	for(int i=1; i<n; i++){
		kek.push_back(make_pair(abs(aim-nums[i]), i));
	}
	sort(kek.begin(), kek.end());
	cout << kek[0].second+1 << endl;
	return 0;
}