#pragma GCС optimize("Pivo_Na_Poly")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <vector>

#define LOCAL

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 1e3;
const ld eps = 1e-6;

int f(int k, int x, int y){
    int res = 0;

    for(int i = 1; i*i <= k; i++){
        int d = k / i;
        if(d * i == k){
            if(d != i)
                res += (d < y && i < x);
            res += (d < x && i < y);
        }
    }

    if(x != y)
        res <<= 1;

    return res;
}

void Solve(){
    int ans = 0, n, x;
    cin >> n >> x;

    for(int i = 2; i < n; i++){
        if(i == x)
            continue;
        for(int j = max(i, n/i); i+j-1 <= n; j++){
            if(j == x)
                continue;
            int k = i*j-n;
            ans += f(k, i, j);
        }
    }

    cout << ans << endl;
}   

/*
3000 0
136814
*/

signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
     

    int q = 1;
    // cin >> q;
   
    while(q--)
        Solve();
}