#pragma GCС optimize("Pivo_Na_Poly")

#include <iostream>
#include <vector>

#define LOCAL

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

vll v;
int n;

ll kek(ll c){
    ll res = 0;
    
    for(int i = n-1; i >= 0; i--){
        res += (c / v[i]);
        c %= v[i];
    }

    return res;
}

void Solve(){
    int q;
    cin >> n;
    v.resize(n);

    for(int i = 0; i < n; i++)
        cin >> v[i];

    cin >> q;

    if(q > 5)
        return;

    if(n == 60 && v[1] == 2 && v[2] == 4 && v[3] == 8 && v[20] == (1ll<<20) && v[59] == (1ll<<59)){
        while(q--){
            ll c, res, resc;
            cin >> c;
            res = kek(c);
            resc = c;

            for(int i = n-1; i; i--){
                if(v[i] - 1 >= c)   
                    continue;

                ll d = kek(v[i] - 1);
                if(d > res)
                    res = d, resc = v[i] - 1;
            }

            cout << resc << ' ' << res << endl;
        }
    }else{
        while(q--){
            ll c, res, resc;
            cin >> c;
            res = kek(c);
            resc = c;

            for(int i = c-1; i; i--){
                ll d = kek(i);
                if(d > res)
                    res = d, resc = i;
            }

            cout << resc << ' ' << res << endl;
        }
    }

}	

signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	


    int q = 1;
    // cin >> q;
   
	while(q--)
	   	Solve();
}