#pragma GCС omptimize("Pivo_Na_Poly")
 
#include <iostream>
#include <vector>

#define LOCAL

#define fi first
#define se second
#define pb push_back
 
using namespace std;
 
typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef vector<char> vchar;
typedef vector<int> vi;
typedef vector<bool> vbool;
typedef vector<pii> vpii;
typedef vector<ll> vll;
typedef vector<vi> vvi; 
typedef vector<vpii> vvpii; 
typedef vector<string> vstring; 
typedef vector<pii> vpii;
typedef vector<vvi> vvvi;

const int mod = 1e9+7;
const int INF32 = 2e9;
const ll INF64 = 4e18;
const int SZ = 2e5;
const ld eps = 1e-6;

vll v;
int n;

ll summ(int l, int r){
    ll res = 0, cnt = 0;

    for(int i = l; i < r; i++)
        res += max(v[i], 0ll);

    for(int i = l+3; i < r; i++)
        if(v[i-3] != -1 && v[i-2] != -1 && v[i-1] != -1 && v[i] != -1)
            return -1;

    if(v[r-3] != -1 && v[r-2] != -1 && v[r-1] != -1 && v[l] != -1)
        return -1;

    if(v[r-2] != -1 && v[r-1] != -1 && v[l] != -1 && v[l+1] != -1)
        return -1;

    if(v[r-1] != -1 && v[l] != -1 && v[l+1] != -1 && v[l+2] != -1)
        return -1;

    return res;
}

ll foo(int l, int r){
    ll res = 0;

    for(int i = l; i < r; i++)
        for(int j = i; j < r; j++)
            for(int k = j; k < r; k++){
                ll a = v[i];
                ll b = v[j];
                ll c = v[k];
                v[i] = -1;
                v[j] = -1;
                v[k] = -1;
                res = max(res, summ(l, r));
                v[i] = a;
                v[j] = b;
                v[k] = c;
            }

    return res;
}

ll f(){
    ll res = 0;

    for(int i = 0; i < n; i++)
        res = max(res, foo(i, i+n));

    return res;
}

void Solve(){
    int q;
    cin >> n;
    v.resize(n<<1);

    for(int i = 0; i < n; i++){
        cin >> v[i];
        v[i+n] = v[i];
    }

    cout << f() << endl;
    cin >> q;

    while(q--){
        int ind, p;
        cin >> ind >> p;
        --ind;
        v[ind] = p;
        v[ind+n] = p;
        cout << f() << endl;
    }
}	

signed main(){
    ios_base::sync_with_stdio(0);
    cout.tie(0);
	cin.tie(0);
 	

    int q = 1;
    // cin >> q;
   
	while(q--)
	   	Solve();
}