#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e5 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, x;
vector <vector <pii> > ab, cd;

void fill_ab(){
	ab.resize(n * n + 1);
	for(int a = 1; a <= n; a++){
		if(a == x)
			continue;
		for(int b = 1; b <= n; b++){
			if(b == x)
				continue;
			ab[a * b].pb({a, b});
		}
	}
}

void fill_cd(){
	cd.resize(n * n + 1);
	for(int a = 1; a <= n; a++){
		for(int b = 1; b <= n; b++)
			cd[a * b].pb({a, b});
	}
} 


int main(){
	fastIO();
	cin >> n >> x;
	
	fill_ab();
	fill_cd();
	
	ll ans = 0;
	for(int i = n + 1; i <= n * n; i++){
		for(auto fst : ab[i]){
			for(auto snd : cd[i - n]){
				if(fst.f > snd.f && fst.s > snd.s)
					ans++;
		 	}
	 	}
	}
	cout << ans;
	return 0;
}