#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <ll, ll> pii;

void fastIO(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const ll MOD = 1e9 + 7;


int n, q;
ll a[MAXN], maxx[MAXN];
ll prefsum[MAXN], prefcnt[MAXN];

pii solve(ll b){
	int l = 0, r = n;
	while(r - l > 1){
		int mid = (l + r) / 2;
		prefsum[mid] <= b ? l = mid : r = mid;
	}
	b -= prefsum[l];
	return {prefsum[l] + a[l] * (b / a[l]), prefcnt[l] + b / a[l]};
}

int main(){
	fastIO();
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> a[i];
	ll val = 0;
	for(int i = 0; i < n - 1; i++){
		ll dif = a[i + 1] - val;
		if(dif % a[i] == 0)
			maxx[i] = dif / a[i] - 1;
		else
			maxx[i] = dif / a[i];
		val += maxx[i] * a[i];
	}
	maxx[n - 1] = INF * INF / a[n - 1] + 1;
	
	for(int i = 1; i < n; i++){
		prefsum[i] = prefsum[i - 1] + maxx[i - 1] * a[i - 1];
		prefcnt[i] = prefcnt[i - 1] + maxx[i - 1];
	}
	
	cin >> q;
	while(q--){
		ll b;
		cin >> b;
		pii ans = solve(b);
		cout << ans.f << ' ' << ans.s << '\n';
	}



	return 0;
}